
import React, { PropTypes } from 'react'
import THREE from 'three'
import { Mesh, Object3D } from '../src'


// http://threejs.org/examples/#webgl_geometry_cube
export default class ExGeometryCube extends Object3D {

  static contextTypes = {
    parent: PropTypes.object,
  };

  constructor (...args) {
    super(...args)
    this.animate = ::this.animate

    this.state = {
      rotation: { x: 0, y: 0 },
      geometry: new THREE.BoxGeometry(1, 1, 1),
      material: new THREE.MeshBasicMaterial({ color: 0x00ffff }),
    }
  }

  componentDidMount (...args) {
    super.componentDidMount(...args)
    this.animate()
  }

  animate () {
    requestAnimationFrame(this.animate)
    const { rotation } = this.state
    this.setState({
      rotation: {
        x: rotation.x + 0.1,
        y: rotation.y + 0.1,
      },
    })
  }

  render () {
    const { rotation } = this.state
    return (
      <Mesh rotation={rotation} geometry={this.state.geometry} material={this.state.material} />
    )
  }
}
